#!/usr/bin/env python
# Riot-E Oracle - Fortunator
# Written by Petri Kuittinen, Feb 2001

import random, re

negative_answers = ["My sources say no", "My reply is no"]
                    
standard_answers = ["Yes",
                    "It is certain",
                    "Definitely yes",
                    "Without a doubt",
                    "You may rely on it",
                    "As I see it yes",
                    "Signs point to yes",
                    "Most likely",
                    "Very doubtful",
                    "Don't count on it",
                    "Outlook not so good"] + negative_answers

all_answers = ["Better not tell you now",
               "Cannot predict now",
               "Reply hazy. Try again",
               "Concentrate and ask again",
               "Ask again later"] + standard_answers

dangerous_words = ["kill", "die", "murder", "hurt", "hit"]

LATER_ANSWER_LIMIT = 10  #after this many questions, use all_answers list

# make regular expression for dangerous words
dangerous_re = re.compile(r"\b(%s)\b" %
                          reduce(lambda x,y: x+"|"+y, dangerous_words))

def reply(question, counter):
    """Return a randomly selected string (= answer).
    Questions with dangerous words always get a negative reply.
    After a certain amount of questions the replies are selected from
    a larger list.
    """
    if dangerous_re.search(question):
        a = negative_answers
    elif counter>=LATER_ANSWER_LIMIT:
        a = all_answers
    else:
        a = standard_answers
    return random.choice(a)        

def test():
    """Give random replies to questions given by user, the test loops until
    end of file (control-d)
    """
    counter = 0
    while 1:
        try:
            question = raw_input ("Question: ")
            if question:
                counter = counter + 1
                print reply(question, counter)
            else:
                print "Please ask a question in English."
        except EOFError:
            break

if __name__ == '__main__':
    test()
